=== debian/changelog ===
transmission (2.94-1~mx15+1) mx; urgency=medium

  * Rebuild for MX 15.
  * Disable the ayatana-appindicators patch, and build against 
    libappindicator3-dev instead.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 26 May 2018 13:11:17 -0700

transmission (2.94-1) unstable; urgency=medium

  * New upstream release
  * refresh patches
  * debian/patches/8c8386a7f3f482a9c917f51d28e0042e55f56b3e.patch,
    debian/patches/bts885151_fix_ftcbfs_ac_run_ifelse.patch
    - dropped, released upstream
  * debian/copyright
    - refresh copyright with `decopy`, most importantly add OpenSSL
      exception
  * debian/control
    - replace libcurl4-gnutls-dev with libcurl4-openssl-dev as b-d, to reduce
      the memory usage of transmission-daemon; patch provided by Andrey Gursky;
      Closes: #865624

 -- Sandro Tosi <morph@debian.org>  Sun, 06 May 2018 19:34:20 -0400

transmission (2.93-2) unstable; urgency=medium

  * debian/control
    - add qt5-qmake:native to b-d, to make it cross buildable; patch by Helmut
      Grohne; Closes: #896699

 -- Sandro Tosi <morph@debian.org>  Thu, 26 Apr 2018 22:54:36 -0400

transmission (2.93-1) unstable; urgency=medium

  * New upstream release; Closes: #890325, #857511, #895869
  * debian/patches/*
    - drop patches merged upstream
  * debian/control
    - bump Standards-Version to 4.1.4 (no changes needed)
    - update Homepage field to use HTTPS
    - update Vcs-* fields to point to salsa
  * enable Ayatana AppIndicator support; Closes: #894410
  * set QT_SELECT=qt5 rather than build-depending on qt5-default; patch by
    Helmut Grohne; Closes: #887849

 -- Sandro Tosi <morph@debian.org>  Sat, 21 Apr 2018 19:19:08 -0400

transmission (2.92-3) unstable; urgency=medium

  * debian/patches/transmission-fix-dns-rebinding-vuln.patch
    - fix RCE execution via dns rebinding attach; fixes CVE-2018-5702;
      Closes: #886990
  * debian/patches/bts885151_fix_ftcbfs_ac_run_ifelse.patch
    - fix a FTCBFS due to use of AC_RUN_IFELSE; Closes: #885151
  * debian/{rules, transmission-qt.install}
    - fix translation load in Qt frontend; patch by Rohan Garg; Closes: #771164
  * debian/control
    - bump Standards-Version t0 4.1.3 (no changes needed)
    - update versioned b-d on debhelper, so that we can drop dh-systemd
  * debian/copyright
    - extend packaging copyright years

 -- Sandro Tosi <morph@debian.org>  Thu, 18 Jan 2018 23:34:22 -0500

transmission (2.92-2) unstable; urgency=medium

  * debian/watch
    - point to transmission-release github repository
  * Support OpenSSL 1.1.0; Closes: #835800
  * debian/copyright
    - point source field to github
    - extend packaging copyright years
  * debian/control
    - use HTTPS for Vcs-* fields
    - drop cmake from b-d, not needed; Closes: #836738
  * debian/patches/transmission-daemon_execstop_service.patch
    - add ExecStop to transmission-daemon service file; Closes: #831467

 -- Sandro Tosi <morph@debian.org>  Sat, 07 Jan 2017 21:15:41 -0500
